// ------------------------------------------------------------------------------
// Curtain - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Curtain.java
// Procedures related to starting up the program and adjusting the settings
// are in this file.
// ------------------------------------------------------------------------------

// Initiate

int numc = 0;                                                  // Number of string segments we are currently at.
int numObstacles = 1;                                          // Number of obstacles.
int numStrings = 10;                                           // Number of strings.
int numStringSegments = 15;                                    // Number of segments in each string.
int numSegments = numStrings*numStringSegments;                // Number of total segments.

float maxd = 25;                                               // The distance at which the segments feel most comfortable with to each other.
float g = 1.0;                                                 // Gravity constant.
float k = 0.99;                                                // Damping constant.
float r = 50;                                                  // Obstacle radius.
float v = 0.9;                                                 // Obstacle damping.
float m = 30;                                                  // Mouse constant

string[] strings;
stringSegment[] stringSegments;
obstacle[] obstacles;

void setup()
{
  size(800,420);
  framerate(40);
  smooth();
  reset();
}

void reset() 
{
  // Create all objects
  
  // Create obstacles
  obstacles = new obstacle[numObstacles];
  for ( int i=0; i<numObstacles; i++ ) { obstacles[i] = new obstacle(); }
  
  // Create strings
  strings = new string[numStrings];
  stringSegments = new stringSegment[numSegments];
  for ( int i=0; i<numStrings; i++ ) { strings[i] = new string(); }
}

void draw()
{
  background(255,255,255);
  
  // Redraw/Recalculate all objects where necessary
 
  for ( int i=0; i<numStrings; i++ )
  {
    strings[i].drawString(width/2+15*(i-numStrings/2), 0,-1,-1);
  }

  if ( mouseX == 0 && mouseX == 0 )
  {
    obstacles[0].obstaclate(-r,-r);
  }
  else
  {
    obstacles[0].obstaclate(mouseX,mouseY);
  }
  
  stroke(0,0,0);
  strokeWeight(3);
  line(300,0,500,0);
}
