// ------------------------------------------------------------------------------
// Curtain - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Obstacle.java
// These objects are are obstacles for the
// string. They block their movement.
// ------------------------------------------------------------------------------

class obstacle
{
  float fx;
  float fy;
  float vx;
  float vy;
  float x;
  float y;

  obstacle()
  {
    x = 400;
    y = 210;
  }
  
  void obstaclate(float X, float Y)
  {
    move(X,Y);
    block();
    display();
  }
  
  void block()
  {
    fx = 0;
    fy = 0;
    
    for ( int i=0; i<numSegments; i++ )
    {
      float deltax = x-stringSegments[i].x;
      float deltay = y-stringSegments[i].y;
      float theta = atan2(deltay,deltax);
      float d = sqrt(pow(deltax,2)+pow(deltay,2));
      
      if ( d < r )
      {
        stringSegments[i].assignPosition(x-r*cos(theta),y-r*sin(theta));
        stringSegments[i].bx = -(r-d)*cos(theta);
        stringSegments[i].by = -(r-d)*sin(theta);
        
        fx = (r-d)*cos(theta);
        fy = (r-d)*sin(theta);
      }
    }
  }
  
  void move(float X, float Y)
  {
    float deltax;
    float deltay;
    
    if (mouseY != 0 || mouseY != 0)
    {
      deltax = X-x;
      deltay = Y-y;
    }
    else
    {
      deltax = 400-x;
      deltay = 210-y;
    }
    
    fx += deltax/m;
    fy += deltay/m;
    
    vx += fx/10;
    vy += fy/10;
    
    x += vx;
    y += vy;
    
    // damping
    vx *= v;
    vy *= v;
  }
  
  void display()
  {
    stroke(0,0,0);
    fill(240,240,240);
    ellipse(x,y,2*r,2*r);
    
    if (mouseX != 0 || mouseY != 0)
    {
      stroke(200,200,200);
      line(x,y,mouseX,mouseY);
      strokeWeight(10);
      stroke(50,50,50);
      point(x,y);
      point(mouseX, mouseY);
    }
  }
}
